# coding: utf-8

"""
    IGVF Project API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 75.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from igvf_client.models.attachment import Attachment
from igvf_client.models.rna_seq_kb_info import RNASeqKBInfo
from typing import Optional, Set
from typing_extensions import Self

class SingleCellRnaSeqQualityMetric(BaseModel):
    """
    Schema for submission of a scRNA-seq uniform pipeline quality metric.
    """ # noqa: E501
    status: Optional[StrictStr] = Field(default=None, description="The status of the metadata object.")
    release_timestamp: Optional[StrictStr] = Field(default=None, description="The date the object was released.")
    attachment: Optional[Attachment] = None
    lab: Optional[StrictStr] = Field(default=None, description="Lab associated with the submission.")
    award: Optional[StrictStr] = Field(default=None, description="Grant associated with the submission.")
    schema_version: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="The version of the JSON schema that the server uses to validate the object.")
    uuid: Optional[StrictStr] = Field(default=None, description="The unique identifier associated with every object.")
    notes: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="DACC internal notes.")
    aliases: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="Lab specific identifiers to reference an object.")
    creation_timestamp: Optional[StrictStr] = Field(default=None, description="The date the object was created.")
    submitted_by: Optional[StrictStr] = Field(default=None, description="The user who submitted the object.")
    submitter_comment: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Additional information specified by the submitter to be displayed as a comment on the portal.")
    description: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="A plain text description of the object.")
    quality_metric_of: Optional[List[StrictStr]] = Field(default=None, description="The file(s) to which this quality metric applies.")
    analysis_step_version: Optional[StrictStr] = Field(default=None, description="The analysis step version of the quality metric.")
    n_records: Optional[Union[StrictFloat, StrictInt]] = None
    n_reads: Optional[Union[StrictFloat, StrictInt]] = None
    n_barcodes: Optional[Union[StrictFloat, StrictInt]] = None
    frac_reads_in_genes_library: Optional[Union[StrictFloat, StrictInt]] = None
    total_umis: Optional[Union[StrictFloat, StrictInt]] = None
    n_barcode_umis: Optional[Union[StrictFloat, StrictInt]] = None
    median_reads_per_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    mean_reads_per_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    median_genes_per_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    median_umis_per_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    mean_umis_per_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    pct_duplicates: Optional[Union[StrictFloat, StrictInt]] = None
    n_genes: Optional[Union[StrictFloat, StrictInt]] = None
    frac_dup: Optional[Union[StrictFloat, StrictInt]] = None
    frac_mito: Optional[Union[StrictFloat, StrictInt]] = None
    frac_mito_genes: Optional[Union[StrictFloat, StrictInt]] = None
    frac_reads_in_genes_barcode: Optional[Union[StrictFloat, StrictInt]] = None
    joint_barcodes_passing: Optional[Union[StrictFloat, StrictInt]] = None
    gt_records: Optional[Union[StrictFloat, StrictInt]] = None
    num_barcodes_on_onlist: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="numBarcodesOnOnlist")
    percentage_barcodes_on_onlist: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="percentageBarcodesOnOnlist")
    num_reads_on_onlist: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="numReadsOnOnlist")
    percentage_reads_on_onlist: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="percentageReadsOnOnlist")
    rnaseq_kb_info: Optional[RNASeqKBInfo] = None
    n_targets: Optional[Union[StrictFloat, StrictInt]] = None
    n_bootstraps: Optional[Union[StrictFloat, StrictInt]] = None
    n_processed: Optional[Union[StrictFloat, StrictInt]] = None
    n_pseudoaligned: Optional[Union[StrictFloat, StrictInt]] = None
    n_unique: Optional[Union[StrictFloat, StrictInt]] = None
    p_pseudoaligned: Optional[Union[StrictFloat, StrictInt]] = None
    p_unique: Optional[Union[StrictFloat, StrictInt]] = None
    index_version: Optional[Union[StrictFloat, StrictInt]] = None
    k_mer_length: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="k-mer length")
    id: Optional[StrictStr] = Field(default=None, alias="@id")
    type: Optional[List[StrictStr]] = Field(default=None, alias="@type")
    summary: Optional[StrictStr] = Field(default=None, description="A summary of the quality metric.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["status", "release_timestamp", "attachment", "lab", "award", "schema_version", "uuid", "notes", "aliases", "creation_timestamp", "submitted_by", "submitter_comment", "description", "quality_metric_of", "analysis_step_version", "n_records", "n_reads", "n_barcodes", "frac_reads_in_genes_library", "total_umis", "n_barcode_umis", "median_reads_per_barcode", "mean_reads_per_barcode", "median_genes_per_barcode", "median_umis_per_barcode", "mean_umis_per_barcode", "pct_duplicates", "n_genes", "frac_dup", "frac_mito", "frac_mito_genes", "frac_reads_in_genes_barcode", "joint_barcodes_passing", "gt_records", "numBarcodesOnOnlist", "percentageBarcodesOnOnlist", "numReadsOnOnlist", "percentageReadsOnOnlist", "rnaseq_kb_info", "n_targets", "n_bootstraps", "n_processed", "n_pseudoaligned", "n_unique", "p_pseudoaligned", "p_unique", "index_version", "k-mer length", "@id", "@type", "summary"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['archived', 'deleted', 'in progress', 'preview', 'released']):
            raise ValueError("must be one of enum values ('archived', 'deleted', 'in progress', 'preview', 'released')")
        return value

    @field_validator('schema_version')
    def schema_version_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^\d+(\.\d+)*$", value):
            raise ValueError(r"must validate the regular expression /^\d+(\.\d+)*$/")
        return value

    @field_validator('notes')
    def notes_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^(\S+(\s|\S)*\S+|\S)$", value):
            raise ValueError(r"must validate the regular expression /^(\S+(\s|\S)*\S+|\S)$/")
        return value

    @field_validator('submitter_comment')
    def submitter_comment_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^(\S+(\s|\S)*\S+|\S)$", value):
            raise ValueError(r"must validate the regular expression /^(\S+(\s|\S)*\S+|\S)$/")
        return value

    @field_validator('description')
    def description_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^(\S+(\s|\S)*\S+|\S)$", value):
            raise ValueError(r"must validate the regular expression /^(\S+(\s|\S)*\S+|\S)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SingleCellRnaSeqQualityMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attachment
        if self.attachment:
            _dict['attachment'] = self.attachment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of rnaseq_kb_info
        if self.rnaseq_kb_info:
            _dict['rnaseq_kb_info'] = self.rnaseq_kb_info.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SingleCellRnaSeqQualityMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": obj.get("status"),
            "release_timestamp": obj.get("release_timestamp"),
            "attachment": Attachment.from_dict(obj["attachment"]) if obj.get("attachment") is not None else None,
            "lab": obj.get("lab"),
            "award": obj.get("award"),
            "schema_version": obj.get("schema_version"),
            "uuid": obj.get("uuid"),
            "notes": obj.get("notes"),
            "aliases": obj.get("aliases"),
            "creation_timestamp": obj.get("creation_timestamp"),
            "submitted_by": obj.get("submitted_by"),
            "submitter_comment": obj.get("submitter_comment"),
            "description": obj.get("description"),
            "quality_metric_of": obj.get("quality_metric_of"),
            "analysis_step_version": obj.get("analysis_step_version"),
            "n_records": obj.get("n_records"),
            "n_reads": obj.get("n_reads"),
            "n_barcodes": obj.get("n_barcodes"),
            "frac_reads_in_genes_library": obj.get("frac_reads_in_genes_library"),
            "total_umis": obj.get("total_umis"),
            "n_barcode_umis": obj.get("n_barcode_umis"),
            "median_reads_per_barcode": obj.get("median_reads_per_barcode"),
            "mean_reads_per_barcode": obj.get("mean_reads_per_barcode"),
            "median_genes_per_barcode": obj.get("median_genes_per_barcode"),
            "median_umis_per_barcode": obj.get("median_umis_per_barcode"),
            "mean_umis_per_barcode": obj.get("mean_umis_per_barcode"),
            "pct_duplicates": obj.get("pct_duplicates"),
            "n_genes": obj.get("n_genes"),
            "frac_dup": obj.get("frac_dup"),
            "frac_mito": obj.get("frac_mito"),
            "frac_mito_genes": obj.get("frac_mito_genes"),
            "frac_reads_in_genes_barcode": obj.get("frac_reads_in_genes_barcode"),
            "joint_barcodes_passing": obj.get("joint_barcodes_passing"),
            "gt_records": obj.get("gt_records"),
            "numBarcodesOnOnlist": obj.get("numBarcodesOnOnlist"),
            "percentageBarcodesOnOnlist": obj.get("percentageBarcodesOnOnlist"),
            "numReadsOnOnlist": obj.get("numReadsOnOnlist"),
            "percentageReadsOnOnlist": obj.get("percentageReadsOnOnlist"),
            "rnaseq_kb_info": RNASeqKBInfo.from_dict(obj["rnaseq_kb_info"]) if obj.get("rnaseq_kb_info") is not None else None,
            "n_targets": obj.get("n_targets"),
            "n_bootstraps": obj.get("n_bootstraps"),
            "n_processed": obj.get("n_processed"),
            "n_pseudoaligned": obj.get("n_pseudoaligned"),
            "n_unique": obj.get("n_unique"),
            "p_pseudoaligned": obj.get("p_pseudoaligned"),
            "p_unique": obj.get("p_unique"),
            "index_version": obj.get("index_version"),
            "k-mer length": obj.get("k-mer length"),
            "@id": obj.get("@id"),
            "@type": obj.get("@type"),
            "summary": obj.get("summary")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


